using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;

namespace CalculAge
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
  private System.Windows.Forms.Label label1;
  private System.Windows.Forms.NumericUpDown udJour;
  private System.Windows.Forms.DomainUpDown udMois;
  private System.Windows.Forms.NumericUpDown udAnne;
  private System.Windows.Forms.Button bCalcul;
  private System.Windows.Forms.Label label2;
  private System.Windows.Forms.NumericUpDown udHeure;
  private System.Windows.Forms.NumericUpDown udMinute;
  private System.Windows.Forms.Label label3;
  private System.Windows.Forms.Label label4;
  private System.Windows.Forms.Label zaJourNaiss;
  private System.Windows.Forms.Label zaAge;
  private System.Windows.Forms.Label zaNbJours;
  private System.Windows.Forms.Label zaNbMinutes;
  private System.Windows.Forms.Label zaNbHeures;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
   // initialisation du contrle UpDown des jours du mois
   string[] nomsMois = CultureInfo.CurrentCulture.DateTimeFormat.MonthNames;
   udMois.Items.Clear();
   udMois.Items.AddRange(nomsMois);
   udMois.Items.RemoveAt(12);
   udMois.SelectedIndex = 0;

   zaJourNaiss.Text = ""; zaAge.Text = ""; zaNbJours.Text = "";
   zaNbHeures.Text = ""; zaNbMinutes.Text = "";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
   System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
   this.zaNbMinutes = new System.Windows.Forms.Label();
   this.udMinute = new System.Windows.Forms.NumericUpDown();
   this.bCalcul = new System.Windows.Forms.Button();
   this.label1 = new System.Windows.Forms.Label();
   this.label3 = new System.Windows.Forms.Label();
   this.udJour = new System.Windows.Forms.NumericUpDown();
   this.label4 = new System.Windows.Forms.Label();
   this.zaNbHeures = new System.Windows.Forms.Label();
   this.zaJourNaiss = new System.Windows.Forms.Label();
   this.zaAge = new System.Windows.Forms.Label();
   this.label2 = new System.Windows.Forms.Label();
   this.udMois = new System.Windows.Forms.DomainUpDown();
   this.zaNbJours = new System.Windows.Forms.Label();
   this.udAnne = new System.Windows.Forms.NumericUpDown();
   this.udHeure = new System.Windows.Forms.NumericUpDown();
   ((System.ComponentModel.ISupportInitialize)(this.udMinute)).BeginInit();
   ((System.ComponentModel.ISupportInitialize)(this.udJour)).BeginInit();
   ((System.ComponentModel.ISupportInitialize)(this.udAnne)).BeginInit();
   ((System.ComponentModel.ISupportInitialize)(this.udHeure)).BeginInit();
   this.SuspendLayout();
   // 
   // zaNbMinutes
   // 
   this.zaNbMinutes.Location = new System.Drawing.Point(16, 256);
   this.zaNbMinutes.Name = "zaNbMinutes";
   this.zaNbMinutes.Size = new System.Drawing.Size(328, 16);
   this.zaNbMinutes.TabIndex = 13;
   this.zaNbMinutes.Text = "NbMinutes";
   // 
   // udMinute
   // 
   this.udMinute.Location = new System.Drawing.Point(304, 32);
   this.udMinute.Maximum = new System.Decimal(new int[] {
                                                         59,
                                                         0,
                                                         0,
                                                         0});
   this.udMinute.Name = "udMinute";
   this.udMinute.Size = new System.Drawing.Size(40, 20);
   this.udMinute.TabIndex = 7;
   this.udMinute.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
   // 
   // bCalcul
   // 
   this.bCalcul.Location = new System.Drawing.Point(140, 72);
   this.bCalcul.Name = "bCalcul";
   this.bCalcul.Size = new System.Drawing.Size(128, 32);
   this.bCalcul.TabIndex = 4;
   this.bCalcul.Text = "Calcul de l\'ge ";
   this.bCalcul.Click += new System.EventHandler(this.bCalcul_Click);
   // 
   // label1
   // 
   this.label1.Location = new System.Drawing.Point(8, 16);
   this.label1.Name = "label1";
   this.label1.Size = new System.Drawing.Size(176, 16);
   this.label1.TabIndex = 0;
   this.label1.Text = "Votre date de naissance :";
   // 
   // label3
   // 
   this.label3.Location = new System.Drawing.Point(256, 32);
   this.label3.Name = "label3";
   this.label3.Size = new System.Drawing.Size(40, 16);
   this.label3.TabIndex = 8;
   this.label3.Text = "heures";
   // 
   // udJour
   // 
   this.udJour.Location = new System.Drawing.Point(8, 32);
   this.udJour.Maximum = new System.Decimal(new int[] {
                                                       31,
                                                       0,
                                                       0,
                                                       0});
   this.udJour.Minimum = new System.Decimal(new int[] {
                                                       1,
                                                       0,
                                                       0,
                                                       0});
   this.udJour.Name = "udJour";
   this.udJour.Size = new System.Drawing.Size(40, 20);
   this.udJour.TabIndex = 1;
   this.udJour.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
   this.udJour.Value = new System.Decimal(new int[] {
                                                     1,
                                                     0,
                                                     0,
                                                     0});
   // 
   // label4
   // 
   this.label4.Location = new System.Drawing.Point(344, 32);
   this.label4.Name = "label4";
   this.label4.Size = new System.Drawing.Size(48, 16);
   this.label4.TabIndex = 9;
   this.label4.Text = "minutes";
   // 
   // zaNbHeures
   // 
   this.zaNbHeures.Location = new System.Drawing.Point(16, 224);
   this.zaNbHeures.Name = "zaNbHeures";
   this.zaNbHeures.Size = new System.Drawing.Size(312, 16);
   this.zaNbHeures.TabIndex = 14;
   this.zaNbHeures.Text = "zaNbHeures";
   // 
   // zaJourNaiss
   // 
   this.zaJourNaiss.Location = new System.Drawing.Point(16, 128);
   this.zaJourNaiss.Name = "zaJourNaiss";
   this.zaJourNaiss.Size = new System.Drawing.Size(360, 16);
   this.zaJourNaiss.TabIndex = 10;
   this.zaJourNaiss.Text = "Jour";
   // 
   // zaAge
   // 
   this.zaAge.Location = new System.Drawing.Point(16, 160);
   this.zaAge.Name = "zaAge";
   this.zaAge.Size = new System.Drawing.Size(336, 16);
   this.zaAge.TabIndex = 11;
   this.zaAge.Text = "Age";
   // 
   // label2
   // 
   this.label2.Location = new System.Drawing.Point(200, 32);
   this.label2.Name = "label2";
   this.label2.Size = new System.Drawing.Size(16, 16);
   this.label2.TabIndex = 5;
   this.label2.Text = "";
   // 
   // udMois
   // 
   this.udMois.Location = new System.Drawing.Point(48, 32);
   this.udMois.Name = "udMois";
   this.udMois.Size = new System.Drawing.Size(80, 20);
   this.udMois.TabIndex = 2;
   this.udMois.Text = "domainUpDown1";
   this.udMois.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
   // 
   // zaNbJours
   // 
   this.zaNbJours.Location = new System.Drawing.Point(16, 192);
   this.zaNbJours.Name = "zaNbJours";
   this.zaNbJours.Size = new System.Drawing.Size(328, 16);
   this.zaNbJours.TabIndex = 12;
   this.zaNbJours.Text = "NbJours";
   // 
   // udAnne
   // 
   this.udAnne.Location = new System.Drawing.Point(128, 32);
   this.udAnne.Maximum = new System.Decimal(new int[] {
                                                        3000,
                                                        0,
                                                        0,
                                                        0});
   this.udAnne.Minimum = new System.Decimal(new int[] {
                                                        1870,
                                                        0,
                                                        0,
                                                        0});
   this.udAnne.Name = "udAnne";
   this.udAnne.Size = new System.Drawing.Size(72, 20);
   this.udAnne.TabIndex = 3;
   this.udAnne.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
   this.udAnne.Value = new System.Decimal(new int[] {
                                                      1980,
                                                      0,
                                                      0,
                                                      0});
   // 
   // udHeure
   // 
   this.udHeure.Location = new System.Drawing.Point(216, 32);
   this.udHeure.Maximum = new System.Decimal(new int[] {
                                                        23,
                                                        0,
                                                        0,
                                                        0});
   this.udHeure.Name = "udHeure";
   this.udHeure.Size = new System.Drawing.Size(40, 20);
   this.udHeure.TabIndex = 6;
   this.udHeure.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
   // 
   // Form1
   // 
   this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
   this.ClientSize = new System.Drawing.Size(408, 285);
   this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                              this.zaNbHeures,
                                                              this.zaNbMinutes,
                                                              this.zaNbJours,
                                                              this.zaAge,
                                                              this.zaJourNaiss,
                                                              this.label4,
                                                              this.label3,
                                                              this.udMinute,
                                                              this.udHeure,
                                                              this.label2,
                                                              this.bCalcul,
                                                              this.udAnne,
                                                              this.udMois,
                                                              this.udJour,
                                                              this.label1});
   this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
   this.Name = "Form1";
   this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
   this.Text = "Calcul de l\'ge";
   ((System.ComponentModel.ISupportInitialize)(this.udMinute)).EndInit();
   ((System.ComponentModel.ISupportInitialize)(this.udJour)).EndInit();
   ((System.ComponentModel.ISupportInitialize)(this.udAnne)).EndInit();
   ((System.ComponentModel.ISupportInitialize)(this.udHeure)).EndInit();
   this.ResumeLayout(false);

  }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

  private void bCalcul_Click(object sender, System.EventArgs e)
  {
   try
   {
    DateTime dt = new DateTime((int)udAnne.Value, udMois.SelectedIndex+1, (int)udJour.Value, (int)udHeure.Value, (int)udMinute.Value, 0);
    if (dt > DateTime.Now) 
    {
     MessageBox.Show("Introduisez une date de naissance plausible, svp", "Erreur sur date");
     return;
    }
    string[] nomsJour = CultureInfo.CurrentCulture.DateTimeFormat.DayNames;
    // Jour de naissance
    zaJourNaiss.Text = "Vous tes n(e) un " + nomsJour[(int)dt.DayOfWeek]; zaJourNaiss.Visible = true;
    int jours, mois, annes, heures, minutes; CalculAge(dt, out annes, out mois, out jours, out heures, out minutes);
    // Age exact
    zaAge.Text = "Vous avez " + annes + " ans, " + mois + " mois, " + jours + " jours, " + heures + " heures et " + minutes + " minutes"; 

    TimeSpan ts = DateTime.Now - dt;
    // Nombre de jours
    double d = Math.Floor(ts.TotalDays); // pour viter les arrondis vers le haut
    string s = d.ToString("###,##0.");
    zaNbJours.Text = "Vous avez vcu " + s + " jours";

    // Nombre d'heures
    s = Math.Floor(ts.TotalHours).ToString("###,##0.");
    zaNbHeures.Text = "Vous avez vcu " + s + " heures";

    // Nombre de minutes
    s = Math.Floor(ts.TotalMinutes).ToString("###,##0.");
    zaNbMinutes.Text = "Vous avez vcu " + s + " minutes";
   }
   catch (Exception)
   {
    zaJourNaiss.Text = ""; zaAge.Text = ""; zaNbJours.Text = "";
    zaNbHeures.Text = ""; zaNbMinutes.Text = "";
    MessageBox.Show("Corrigez la date de naissance !", "Erreur sur date");
   }
  }

  public void CalculAge(DateTime dn, out int ans, out int mois, out int jours, out int heures, out int minutes)
  {            
   DateTime dj=DateTime.Now;
   mois = jours = 0;
   TimeSpan ts = dj - dn;
   heures = (int)ts.TotalHours  % 24;
   minutes = (int)ts.TotalMinutes % 60;
  
   DateTime d3;
   for (ans=(int)ts.TotalDays/365; dn.AddYears(ans)>dj; ans--) ;
   if (dn.AddYears(ans)==dj) return;
   else 
   {
    d3 = dn.AddYears(ans);
    for (mois=12; d3.AddMonths(mois)>dj; mois--) ;
    if (d3.AddMonths(mois)==dj) return;
    else
    {
     d3 = d3.AddMonths(mois);
     for (jours=31; d3.AddDays(jours)>dj; jours--) ;
     return;
    } 
   }
  }
	}
}
